package com.googlecode.jpattern.gwt.client;

/**
 * 
 * @author Francesco Cina'
 *
 * 12 Apr 2011
 */
public class ApplicationProxy {
	
	private static ApplicationProxy APPLICATION_PROXY = new ApplicationProxy();
	private IApplicationProvider applicationProvider = new NullApplicationProvider();
	
	private ApplicationProxy() {
		
	}
	
	public static ApplicationProxy getInstance() {
		return APPLICATION_PROXY;
	}
	
	public void setApplicationProvider(IApplicationProvider applicationProvider) {
		if (applicationProvider!=null) {
			this.applicationProvider = applicationProvider;
		}
	}
	
	public IApplicationProvider getApplicationProvider() {
		return applicationProvider;
	}

}
